Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/tesselation.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1589,119 +2222,233 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
+          DoeLog(1) && (eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl);
         }
       }
   }
 
-  Log() << Verbose(2) << "Found maximum coordinates: ";
-  for (int i=0;i<NDIM;i++)
-    Log() << Verbose(0) << i << ": " << *MaxPoint[i] << "\t";
-  Log() << Verbose(0) << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Found maximum coordinates: ");
+  for (int i = 0; i < NDIM; i++)
+    DoLog(0) && (Log() << Verbose(0) << i << ": " << *MaxPoint[i] << "\t");
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
   BTS = NULL;
-  CandidateList *OptCandidates = new CandidateList();
-  for (int k=0;k<NDIM;k++) {
-    Oben.Zero();
-    Oben.x[k] = 1.;
-    FirstPoint = MaxPoint[k];
-    Log() << Verbose(1) << "Coordinates of start node at " << *FirstPoint->node << "." << endl;
+  for (int k = 0; k < NDIM; k++) {
+    NormalVector.Zero();
+    NormalVector.x[k] = 1.;
+    BaseLine = new BoundaryLineSet();
+    BaseLine->endpoints[0] = new BoundaryPointSet(MaxPoint[k]);
+    DoLog(0) && (Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine->endpoints[0]->node << "." << endl);
 
     double ShortestAngle;
-    TesselPoint* OptCandidate = NULL;
     ShortestAngle = 999999.; // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
 
-    FindSecondPointForTesselation(FirstPoint, Oben, OptCandidate, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
-    SecondPoint = OptCandidate;
-    if (SecondPoint == NULL)  // have we found a second point?
+    Temporary = NULL;
+    FindSecondPointForTesselation(BaseLine->endpoints[0]->node, NormalVector, Temporary, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
+    if (Temporary == NULL) {
+      // have we found a second point?
+      delete BaseLine;
       continue;
-
-    helper.CopyVector(FirstPoint->node);
-    helper.SubtractVector(SecondPoint->node);
-    helper.Normalize();
-    Oben.ProjectOntoPlane(&helper);
-    Oben.Normalize();
-    helper.VectorProduct(&Oben);
-    ShortestAngle = 2.*M_PI; // This will indicate the quadrant.
-
-    Chord.CopyVector(FirstPoint->node); // bring into calling function
-    Chord.SubtractVector(SecondPoint->node);
-    double radius = Chord.ScalarProduct(&Chord);
-    double CircleRadius = sqrt(RADIUS*RADIUS - radius/4.);
-    helper.CopyVector(&Oben);
-    helper.Scale(CircleRadius);
-    // Now, oben and helper are two orthonormalized vectors in the plane defined by Chord (not normalized)
+    }
+    BaseLine->endpoints[1] = new BoundaryPointSet(Temporary);
+
+    // construct center of circle
+    CircleCenter.CopyVector(BaseLine->endpoints[0]->node->node);
+    CircleCenter.AddVector(BaseLine->endpoints[1]->node->node);
+    CircleCenter.Scale(0.5);
+
+    // construct normal vector of circle
+    CirclePlaneNormal.CopyVector(BaseLine->endpoints[0]->node->node);
+    CirclePlaneNormal.SubtractVector(BaseLine->endpoints[1]->node->node);
+
+    double radius = CirclePlaneNormal.NormSquared();
+    double CircleRadius = sqrt(RADIUS * RADIUS - radius / 4.);
+
+    NormalVector.ProjectOntoPlane(&CirclePlaneNormal);
+    NormalVector.Normalize();
+    ShortestAngle = 2. * M_PI; // This will indicate the quadrant.
+
+    SphereCenter.CopyVector(&NormalVector);
+    SphereCenter.Scale(CircleRadius);
+    SphereCenter.AddVector(&CircleCenter);
+    // Now, NormalVector and SphereCenter are two orthonormalized vectors in the plane defined by CirclePlaneNormal (not normalized)
 
     // look in one direction of baseline for initial candidate
-    SearchDirection.MakeNormalVector(&Chord, &Oben);  // whether we look "left" first or "right" first is not important ...
+    SearchDirection.MakeNormalVector(&CirclePlaneNormal, &NormalVector); // whether we look "left" first or "right" first is not important ...
 
     // adding point 1 and point 2 and add the line between them
-    Log() << Verbose(1) << "Coordinates of start node at " << *FirstPoint->node << "." << endl;
-    AddTesselationPoint(FirstPoint, 0);
-    Log() << Verbose(1) << "Found second point is at " << *SecondPoint->node << ".\n";
-    AddTesselationPoint(SecondPoint, 1);
-    AddTesselationLine(TPS[0], TPS[1], 0);
-
-    //Log() << Verbose(2) << "INFO: OldSphereCenter is at " << helper << ".\n";
-    FindThirdPointForTesselation(Oben, SearchDirection, helper, BLS[0], NULL, *&OptCandidates, &ShortestAngle, RADIUS, LC);
-    Log() << Verbose(1) << "List of third Points is ";
-    for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-        Log() << Verbose(0) << " " << *(*it)->point;
-    }
-    Log() << Verbose(0) << endl;
-
-    for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-      // add third triangle point
-      AddTesselationPoint((*it)->point, 2);
-      // add the second and third line
-      AddTesselationLine(TPS[1], TPS[2], 1);
-      AddTesselationLine(TPS[0], TPS[2], 2);
-      // ... and triangles to the Maps of the Tesselation class
-      BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-      AddTesselationTriangle();
-      // ... and calculate its normal vector (with correct orientation)
-      (*it)->OptCenter.Scale(-1.);
-      Log() << Verbose(2) << "Anti-Oben is currently " << (*it)->OptCenter << "." << endl;
-      BTS->GetNormalVector((*it)->OptCenter);  // vector to compare with should point inwards
-      Log() << Verbose(0) << "==> Found starting triangle consists of " << *FirstPoint << ", " << *SecondPoint << " and "
-      << *(*it)->point << " with normal vector " << BTS->NormalVector << ".\n";
-
-      // if we do not reach the end with the next step of iteration, we need to setup a new first line
-      if (it != OptCandidates->end()--) {
-        FirstPoint = (*it)->BaseLine->endpoints[0]->node;
-        SecondPoint = (*it)->point;
-        // adding point 1 and point 2 and the line between them
-        AddTesselationPoint(FirstPoint, 0);
-        AddTesselationPoint(SecondPoint, 1);
-        AddTesselationLine(TPS[0], TPS[1], 0);
-      }
-      Log() << Verbose(2) << "Projection is " << BTS->NormalVector.ScalarProduct(&Oben) << "." << endl;
-    }
-    if (BTS != NULL) // we have created one starting triangle
+    DoLog(0) && (Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine->endpoints[0]->node << "." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "Found second point is at " << *BaseLine->endpoints[1]->node << ".\n");
+
+    //Log() << Verbose(1) << "INFO: OldSphereCenter is at " << helper << ".\n";
+    CandidateForTesselation OptCandidates(BaseLine);
+    FindThirdPointForTesselation(NormalVector, SearchDirection, SphereCenter, OptCandidates, NULL, RADIUS, LC);
+    DoLog(0) && (Log() << Verbose(0) << "List of third Points is:" << endl);
+    for (TesselPointList::iterator it = OptCandidates.pointlist.begin(); it != OptCandidates.pointlist.end(); it++) {
+      DoLog(0) && (Log() << Verbose(0) << " " << *(*it) << endl);
+    }
+    if (!OptCandidates.pointlist.empty()) {
+      BTS = NULL;
+      AddCandidatePolygon(OptCandidates, RADIUS, LC);
+    } else {
+      delete BaseLine;
+      continue;
+    }
+
+    if (BTS != NULL) { // we have created one starting triangle
+      delete BaseLine;
       break;
-    else {
+    } else {
       // remove all candidates from the list and then the list itself
-      class CandidateForTesselation *remover = NULL;
-      for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-        remover = *it;
-        delete(remover);
-      }
-      OptCandidates->clear();
-    }
-  }
-
-  // remove all candidates from the list and then the list itself
-  class CandidateForTesselation *remover = NULL;
-  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-    remover = *it;
-    delete(remover);
-  }
-  delete(OptCandidates);
-  Log() << Verbose(1) << "End of FindStartingTriangle\n";
-};
-
+      OptCandidates.pointlist.clear();
+    }
+    delete BaseLine;
+  }
+
+  return (BTS != NULL);
+}
+;
+
+/** Checks for a given baseline and a third point candidate whether baselines of the found triangle don't have even better candidates.
+ * This is supposed to prevent early closing of the tesselation.
+ * \param CandidateLine CandidateForTesselation with baseline and shortestangle , i.e. not \a *OptCandidate
+ * \param *ThirdNode third point in triangle, not in BoundaryLineSet::endpoints
+ * \param RADIUS radius of sphere
+ * \param *LC LinkedCell structure
+ * \return true - there is a better candidate (smaller angle than \a ShortestAngle), false - no better TesselPoint candidate found
+ */
+//bool Tesselation::HasOtherBaselineBetterCandidate(CandidateForTesselation &CandidateLine, const TesselPoint * const ThirdNode, double RADIUS, const LinkedCell * const LC) const
+//{
+//	Info FunctionInfo(__func__);
+//  bool result = false;
+//  Vector CircleCenter;
+//  Vector CirclePlaneNormal;
+//  Vector OldSphereCenter;
+//  Vector SearchDirection;
+//  Vector helper;
+//  TesselPoint *OtherOptCandidate = NULL;
+//  double OtherShortestAngle = 2.*M_PI; // This will indicate the quadrant.
+//  double radius, CircleRadius;
+//  BoundaryLineSet *Line = NULL;
+//  BoundaryTriangleSet *T = NULL;
+//
+//  // check both other lines
+//  PointMap::const_iterator FindPoint = PointsOnBoundary.find(ThirdNode->nr);
+//  if (FindPoint != PointsOnBoundary.end()) {
+//    for (int i=0;i<2;i++) {
+//      LineMap::const_iterator FindLine = (FindPoint->second)->lines.find(BaseRay->endpoints[0]->node->nr);
+//      if (FindLine != (FindPoint->second)->lines.end()) {
+//        Line = FindLine->second;
+//        Log() << Verbose(0) << "Found line " << *Line << "." << endl;
+//        if (Line->triangles.size() == 1) {
+//          T = Line->triangles.begin()->second;
+//          // construct center of circle
+//          CircleCenter.CopyVector(Line->endpoints[0]->node->node);
+//          CircleCenter.AddVector(Line->endpoints[1]->node->node);
+//          CircleCenter.Scale(0.5);
+//
+//          // construct normal vector of circle
+//          CirclePlaneNormal.CopyVector(Line->endpoints[0]->node->node);
+//          CirclePlaneNormal.SubtractVector(Line->endpoints[1]->node->node);
+//
+//          // calculate squared radius of circle
+//          radius = CirclePlaneNormal.ScalarProduct(&CirclePlaneNormal);
+//          if (radius/4. < RADIUS*RADIUS) {
+//            CircleRadius = RADIUS*RADIUS - radius/4.;
+//            CirclePlaneNormal.Normalize();
+//            //Log() << Verbose(1) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
+//
+//            // construct old center
+//            GetCenterofCircumcircle(&OldSphereCenter, *T->endpoints[0]->node->node, *T->endpoints[1]->node->node, *T->endpoints[2]->node->node);
+//            helper.CopyVector(&T->NormalVector);  // normal vector ensures that this is correct center of the two possible ones
+//            radius = Line->endpoints[0]->node->node->DistanceSquared(&OldSphereCenter);
+//            helper.Scale(sqrt(RADIUS*RADIUS - radius));
+//            OldSphereCenter.AddVector(&helper);
+//            OldSphereCenter.SubtractVector(&CircleCenter);
+//            //Log() << Verbose(1) << "INFO: OldSphereCenter is at " << OldSphereCenter << "." << endl;
+//
+//            // construct SearchDirection
+//            SearchDirection.MakeNormalVector(&T->NormalVector, &CirclePlaneNormal);
+//            helper.CopyVector(Line->endpoints[0]->node->node);
+//            helper.SubtractVector(ThirdNode->node);
+//            if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
+//              SearchDirection.Scale(-1.);
+//            SearchDirection.ProjectOntoPlane(&OldSphereCenter);
+//            SearchDirection.Normalize();
+//            Log() << Verbose(1) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
+//            if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
+//              // rotated the wrong way!
+//              DoeLog(1) && (eLog()<< Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl);
+//            }
+//
+//            // add third point
+//            FindThirdPointForTesselation(T->NormalVector, SearchDirection, OldSphereCenter, OptCandidates, ThirdNode, RADIUS, LC);
+//            for (TesselPointList::iterator it = OptCandidates.pointlist.begin(); it != OptCandidates.pointlist.end(); ++it) {
+//              if (((*it) == BaseRay->endpoints[0]->node) || ((*it) == BaseRay->endpoints[1]->node)) // skip if it's the same triangle than suggested
+//                continue;
+//              Log() << Verbose(0) << " Third point candidate is " << (*it)
+//              << " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
+//              Log() << Verbose(0) << " Baseline is " << *BaseRay << endl;
+//
+//              // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
+//              TesselPoint *PointCandidates[3];
+//              PointCandidates[0] = (*it);
+//              PointCandidates[1] = BaseRay->endpoints[0]->node;
+//              PointCandidates[2] = BaseRay->endpoints[1]->node;
+//              bool check=false;
+//              int existentTrianglesCount = CheckPresenceOfTriangle(PointCandidates);
+//              // If there is no triangle, add it regularly.
+//              if (existentTrianglesCount == 0) {
+//                SetTesselationPoint((*it), 0);
+//                SetTesselationPoint(BaseRay->endpoints[0]->node, 1);
+//                SetTesselationPoint(BaseRay->endpoints[1]->node, 2);
+//
+//                if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
+//                  OtherOptCandidate = (*it);
+//                  check = true;
+//                }
+//              } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
+//                SetTesselationPoint((*it), 0);
+//                SetTesselationPoint(BaseRay->endpoints[0]->node, 1);
+//                SetTesselationPoint(BaseRay->endpoints[1]->node, 2);
+//
+//                // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
+//                // i.e. at least one of the three lines must be present with TriangleCount <= 1
+//                if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS)) {
+//                  OtherOptCandidate = (*it);
+//                  check = true;
+//                }
+//              }
+//
+//              if (check) {
+//                if (ShortestAngle > OtherShortestAngle) {
+//                  Log() << Verbose(0) << "There is a better candidate than " << *ThirdNode << " with " << ShortestAngle << " from baseline " << *Line << ": " << *OtherOptCandidate << " with " << OtherShortestAngle << "." << endl;
+//                  result = true;
+//                  break;
+//                }
+//              }
+//            }
+//            delete(OptCandidates);
+//            if (result)
+//              break;
+//          } else {
+//            Log() << Verbose(0) << "Circumcircle for base line " << *Line << " and base triangle " << T << " is too big!" << endl;
+//          }
+//        } else {
+//          DoeLog(2) && (eLog()<< Verbose(2) << "Baseline is connected to two triangles already?" << endl);
+//        }
+//      } else {
+//        Log() << Verbose(1) << "No present baseline between " << BaseRay->endpoints[0] << " and candidate " << *ThirdNode << "." << endl;
+//      }
+//    }
+//  } else {
+//    DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the TesselPoint " << *ThirdNode << "." << endl);
+//  }
+//
+//  return result;
+//};
 
 /** This function finds a triangle to a line, adjacent to an existing one.
  * @param out output stream for debugging
- * @param Line current baseline to search from
+ * @param CandidateLine current cadndiate baseline to search from
  * @param T current triangle which \a Line is edge of
  * @param RADIUS radius of the rolling ball
